<template>
  <!-- Main container -->
  <div class="xl:w-1/4 lg:w-1/3 md:w-2/5 sm:w-1/2 w-full mx-auto py-16 px-4">

    <!-- Title -->
    <h1 class="text-center">{{ $t('views.ResetPassword.title') | capitalize }}</h1>

    <!-- Form container -->
    <div>
      <!-- ResetPasswordForm -->
      <ResetPasswordForm
        v-if="!passwordChanged"
        :token="token"
        @password-changed="passwordChanged = true"
      />
      <div class="text-center" v-else>
        <!-- Illus -->
        <div class="mb-4">
          <v-icon name="check" scale="5" class="text-action"/>
        </div>
        <!-- Password changed text -->
        <p class="mb-8">{{ $t('user.passwordChanged') }}</p>
        <!-- Router link to login -->
        <Button to="/login" variant="action" inline>{{ $t('user.signIn') | capitalize }}</Button>
      </div>
    </div>

  </div>
</template>

<script>
// Components
import ResetPasswordForm from './ResetPasswordForm'
/**
 * ResetPassword component
 */
export default {
  name: 'ResetPassword',
  components: {
    ResetPasswordForm
  },
  data () {
    return {
      token: null,
      passwordChanged: false
    }
  },
  beforeRouteEnter (to, from, next) {
    // does NOT have access to `this` component instance
    if (to.params.token && to.params.token.length > 0) {
      next()
    } else {
      next({ name: '404' })
    }
  },
  beforeRouteUpdate (to, from, next) {
    // has access to `this` component instance.
    if (to.params.token && to.params.token.length > 0) {
      this.token = to.params.token
      next()
    } else {
      next({ name: '404' })
    }
  },
  mounted () {
    this.token = this.$route.params.token
  }
}
</script>
